## open-iscsi 2.1.1

=== debian/changelog ===
open-iscsi (2.1.1-1ubuntu2.1) groovy; urgency=medium

  * d/open-iscsi.finalrd: fix UID resolution issues in logout (LP: #1922976)
    Thanks to Michael Brown

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Thu, 18 Mar 2021 09:44:07 +0100

open-iscsi (2.1.1-1ubuntu2) groovy; urgency=medium

  * debian/control, debian/rules: Fix libopeniscsiusr binary package
    name (LP: #1892228).
  * debian/rules: Fix deprecated warning for dh_installinit that
    --no-restart-on-upgrade has been replaced by --no-stop-on-upgrade,
    which is equivalent in functionality (ref deb #837528).

 -- Rafael David Tinoco <rafaeldtinoco@ubuntu.com>  Wed, 19 Aug 2020 19:08:47 +0000

open-iscsi (2.1.1-1ubuntu1) groovy; urgency=medium

  * New upstream version 2.1.1
  * d/rules: Don't FTBFS due to warnings new in gcc10 regarding bounds
    and initialization, because upstream's gcc10 support is incomplete.
    This change can be dropped when upstream has completed their gcc
    support.
  * Merge with Debian unstable (LP: #1891374). Remaining changes:
    - debian/tests: Add Ubuntu autopkgtest suite:
      - README-boot-test.md
      - tgt-boot-test: tests
      - test-open-iscsi.py
      - testlib.py
      - get-image
      - patch-image
      - testsuite
      - xkvm
    - d/iscsid.service: Let iscsid systemd job run in privileged containers
      but not in unprivileged ones
    - d/extra/initramfs.local-top: handle iSCSI iBFT DHCP to correctly
      run ipconfig to gather all DHCP config info, including DNS search
      domain, which iBFT can't provide.
    - Remove initramfs interfaces stamp in case no iscsi devs mounted.
      If iscsi root was requested, but no iscsi devices were mounted, remove
      the initramfs interfaces stamp file. Meaning, that on shutdown there is
      no 30s delay, whilst trying to re-establish iscsi login to perform a
      logout.
    - add IPv6 support
      - Source /run/net6-*.conf when needed.
      - d/extra/initramfs.local-top: handle IPv6 configs being shipped in
        DEVICE6 or /run/net6-*.conf in the initramfs, so we can fill in
        .interface
    - d/rules, d/open-iscsi.finalrd, d/control: ship the finalrd iscsi logout
      hook and recommend finalrd and busybox for the logout hook to work.
    - Make iscsid socket-activated to only activate it as needed:
      - debian/open-iscsi.service: do not start or check iscsid.service
      - debian/rules: install and enable iscsid.socket
      - debian/open-iscsi.postinst:
        - run restart logic only if service is running on upgrade
        - drop no longer reachable upgrade path that affects iscsid
        - disable iscsid.service on upgrade
        - handle iscsid.socket to be started if the service is not running yet
      - d/iscsi-disk.rules: Add a udev rule so that iscsid.service will be
        run when udev disks are attached.
      - d/iscsid.service: Remove ExecStop= directive.
      - debian/tests/install: fix tests to work with socket activation
      - debian/patches/lp1755858-default-iscsid_conf-to-iscsid_socket.patch
    - debian/open-iscsi.service: Start open-iscsi systemd job when either
      /etc/iscsi/nodes or /sys/class/iscsi_session have content.
    - Prevent network interface that contains iscsi root from bouncing
      during boot or going down during shutdown if the system is using
      resolvconf or ifupdown:
      - d/iscsi-network-interface.rules
      - d/extra/net-interface-handler
    - d/extra/initramfs.hook: add ib_iser to the list of modules included in
      the initramfs, so that we can in principle support iscsi root on
      infiniband.
    - d/open-iscsi.kmod drop: (LP #1833586)
      no static module list is needed if we let iscsid load modules itself.
    - Stop producing udebs on i386 where we no longer have d-i or a kernel.
    - Use python2 instead of python in the autopkg tests: Next step for
      open-iscsi is to revist all iscsi-root feature and autopkgtests, so
      keep python2 to avoid re-work later.
    - d/extra/initramfs.local-{top,bottom}: move removal of
      open-iscsi.interface file from local-top to local-bottom, and fix shell
      quoting issue that would result in /run/initramfs/ open-iscsi.interface
      always being removed (LP #1872813)

 -- Rafael David Tinoco <rafaeldtinoco@ubuntu.com>  Thu, 13 Aug 2020 04:29:43 +0000

open-iscsi (2.1.1-1) experimental; urgency=medium

  [ Rafael David Tinoco ]
  * New upstream version 2.1.1:
    - [76d0a49] Remove OpenSSL dependency due to GPL license conflict
    - [5f12ebf] Bump compatibility
    - [44034fb] Updates to debian/rules:
      - Update package description from upstream documentation
      - Update Standards-Version
      - Update Build-Depends and Depends
      - Create new needed packages (open-iscsi userland library)
    - [f4f0987] Update copyright and fix lintian complains
    - [37cef72] status command defined to show active sessions
    - [4b93bb8] Remove old post-installation workaround and update path
    - [0a5ec77] Remove rest of unneeded old update path (abort-upgrade)
    - [a4762f0] Remove rest of unneeded old update path (upgrade)
    - [6915ce5] iscsid.service is needed whenever iscsi disks are added
    - [1002212] Update tests dependencies
    - [d3b6647] Workaround for Flex 2.5.35 is not needed anymore
    - [396b15a] Use debian/rules for dh overrides (easier to manage)
    - [3427d74] Remove old openssl patch to licensing issue:
      - d/p/debian/dont-link-against-openssl.patch
    - [dc3cfaf] Drop unneeded patches for v2.1.1:
      - bugfixes/no-make-clean-kernel.patch (2.0.875-47-gb4a1cef)
      - debian/var-run-lock.patch (2.0.877-27-g0f30033)
      - debian/udeb-without-libmount.patch (libmount1-dbgsym:2.35.1-5)
      - bugfixes/need_iscsiuio_for_hardware_offload.patch (2.0.873-214-gf780a82)
      - bugfixes/move_offload_discovery_to_fw_get_targets.patch (2.0.873-215-g3ae35d3)
      - bugfixes/fix_iscsiuio_long_options.patch (2.0.873-216-g0685179)


=== debian/control ===
Source: open-iscsi
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian iSCSI Maintainers <open-iscsi@packages.debian.org>
Uploaders: Ritesh Raj Sarraf <rrs@debian.org>,
           Christian Seiler <christian@iwakd.de>
Build-Depends: bison,
               bzip2,
               debhelper (>= 10),
               dh-exec,
               dpkg-dev (>= 1.19),
               flex,
               libisns-dev,
               libmount-dev,
               pkg-config,
               libkmod-dev,
               libsystemd-dev,
               libssl-dev
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/linux-blocks-team/open-iscsi.git
Vcs-Browser: https://salsa.debian.org/linux-blocks-team/open-iscsi.git
Homepage: http://www.open-iscsi.com/
Testsuite: autopkgtest
Rules-Requires-Root: no

Package: open-iscsi
Architecture: linux-any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libopeniscsiusr0.2.0,
         udev
Recommends: ${busybox:Recommends}, finalrd (>= 3)
Pre-Depends: debconf | debconf-2.0
Description: iSCSI initiator tools
 The Open-iSCSI project is a high-performance, transport independent,
 multi-platform implementation of RFC3720 iSCSI.
 .
 Open-iSCSI is partitioned into user and kernel parts.
 .
 The kernel portion of Open-iSCSI is a from-scratch code
 licensed under GPL. The kernel part implements iSCSI data path
 (that is, iSCSI Read and iSCSI Write), and consists of three
 loadable modules: scsi_transport_iscsi.ko, libiscsi.ko and iscsi_tcp.ko.
 .
 User space contains the entire control plane: configuration
 manager, iSCSI Discovery, Login and Logout processing,
 connection-level error processing, Nop-In and Nop-Out handling,
 and (in the future:) Text processing, iSNS, SLP, Radius, etc.
 .
 The user space Open-iSCSI consists of a daemon process called
 iscsid, and a management utility iscsiadm.
 .
 This package includes a daemon, iscsid, and a management utility,
 iscsiadm.

Package: libopeniscsiusr0.2.0
Architecture: linux-any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Enhances: open-iscsi
Description: iSCSI userspace library
 The Open-iSCSI project is a high-performance, transport independent,
 multi-platform implementation of RFC3720 iSCSI.
 .
 Open-iSCSI is partitioned into user and kernel parts.
 .
 The kernel portion of Open-iSCSI is a from-scratch code
 licensed under GPL. The kernel part implements iSCSI data path
 (that is, iSCSI Read and iSCSI Write), and consists of three
 loadable modules: scsi_transport_iscsi.ko, libiscsi.ko and iscsi_tcp.ko.
 .
 User space contains the entire control plane: configuration
 manager, iSCSI Discovery, Login and Logout processing,
 connection-level error processing, Nop-In and Nop-Out handling,
 and (in the future:) Text processing, iSNS, SLP, Radius, etc.
 .
 The user space Open-iSCSI consists of a daemon process called
 iscsid, and a management utility iscsiadm.
 .
 This package contains the iSCSI userspace library.

Package: libopeniscsiusr-dev
Architecture: linux-any
Depends: ${misc:Depends},
         libopeniscsiusr0.2.0 (= ${binary:Version})
Enhances: open-iscsi
Description: iSCSI userspace library headers
 The Open-iSCSI project is a high-performance, transport independent,
 multi-platform implementation of RFC3720 iSCSI.
 .
 Open-iSCSI is partitioned into user and kernel parts.
 .
 The kernel portion of Open-iSCSI is a from-scratch code
 licensed under GPL. The kernel part implements iSCSI data path
 (that is, iSCSI Read and iSCSI Write), and consists of three
 loadable modules: scsi_transport_iscsi.ko, libiscsi.ko and iscsi_tcp.ko.
 .
 User space contains the entire control plane: configuration
 manager, iSCSI Discovery, Login and Logout processing,
 connection-level error processing, Nop-In and Nop-Out handling,
 and (in the future:) Text processing, iSNS, SLP, Radius, etc.
 .
 The user space Open-iSCSI consists of a daemon process called
 iscsid, and a management utility iscsiadm.
 .
 This package contains the iSCSI userspace library headers.

Package: iscsiuio
Architecture: linux-any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libopeniscsiusr0.2.0,
         udev
Enhances: open-iscsi
Description: iSCSI offloading daemon for QLogic devices
 The Open-iSCSI project is a high-performance, transport independent,
 multi-platform implementation of RFC3720 iSCSI.
 .
 This tool is to be used in conjunction with the QLogic NetXtreme II Linux
 driver (Kernel module name: 'bnx2' and 'bnx2x'), QLogic CNIC driver,
 and the QLogic iSCSI driver (Kernel module name: 'bnx2i').
 .
 This user space tool is used in conjunction with the following
 QLogic Network Controllers:
   bnx2:  BCM5706, BCM5708, BCM5709 devices
   bnx2x: BCM57710, BCM57711, BCM57711E, BCM57712, BCM57712E,
          BCM57800, BCM57810, BCM57840 devices
 .
 This utility will provide the ARP and DHCP functionality for the iSCSI
 offload. The communication to the driver is done via Userspace I/O (Kernel
 module name 'uio').
 .
 This package is required to offload iSCSI onto these devices.

Package: open-iscsi-udeb
# Note: the (virtual) udeb package scsi-modules (provided by different
#       linux kernel udebs) must exist for these architectures - so
#       check that before adding them to this list; the other
#       scsi-(core|common|...)-modules are NOT sufficient!
Architecture: amd64 arm64 armhf ia64 mips mipsel powerpc ppc64 ppc64el s390x
Section: debian-installer
Package-Type: udeb
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libopeniscsiusr0.2.0,
         udev,
         scsi-modules
Description: Configure iSCSI
 The Open-iSCSI project is a high-performance, transport independent,
 multi-platform implementation of RFC3720 iSCSI.
 .
 This is the minimal package (udeb) used by debian-installer.

=== debian/rules ===
#!/usr/bin/make -f
# export DH_VERBOSE = 1

DEB_HOST_MULTIARCH  ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

SOURCE := $(shell dpkg-parsechangelog | sed -ne 's,^Source: *\(.*\)$$,\1,p')
VERSION_COMPLETE := $(shell dpkg-parsechangelog | sed -ne 's,^Version: *\(.*\)$$,\1,p')
VERSION_DEBIAN := $(shell echo "$(VERSION_COMPLETE)" | sed -e 's,^[^-]*-,,')

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# Fix gcc10 warnings as errors while upstream doesn't catch up
export DEB_CFLAGS_PREPEND=-Wno-error=zero-length-bounds -Wno-error=format-overflow= -Wno-error=format-truncation= -Wno-error=maybe-uninitialized
export DEB_CXXFLAGS_PREPEND=${DEB_CFLAGS_PREPEND}

%:
	dh $@

override_dh_update_autotools_config:
override_autoreconf:
override_dh_auto_configure:

override_dh_auto_build:
	CFLAGS="$(CPPFLAGS) $(CFLAGS)" dh_auto_build

override_dh_auto_install:

	@# libopeniscsiusr
	dh_install -p libopeniscsiusr0.2.0 libopeniscsiusr/libopeniscsiusr.so.* usr/lib/${DEB_HOST_MULTIARCH}

	@# libopeniscsi-dev
	dh_install -p libopeniscsiusr-dev libopeniscsiusr/libopeniscsiusr.so usr/lib/${DEB_HOST_MULTIARCH}
	dh_install -p libopeniscsiusr-dev libopeniscsiusr/libopeniscsiusr/ usr/include/

	@# open-iscsi
	dh_install -p open-iscsi usr/iscsid sbin/
	dh_install -p open-iscsi usr/iscsistart sbin/
	dh_install -p open-iscsi usr/iscsiadm sbin/
	dh_install -p open-iscsi utils/iscsi_discovery sbin/
	dh_install -p open-iscsi utils/iscsi-iname sbin/
	dh_install -p open-iscsi etc/iscsid.conf etc/iscsi/
	dh_install -p open-iscsi debian/extra/umountiscsi.sh lib/open-iscsi/
	dh_install -p open-iscsi debian/extra/logout-all.sh lib/open-iscsi/
	dh_install -p open-iscsi debian/extra/startup-checks.sh lib/open-iscsi/
	dh_install -p open-iscsi debian/extra/activate-storage.sh lib/open-iscsi/
	dh_install -p open-iscsi debian/extra/net-interface-handler lib/open-iscsi/
	dh_install -p open-iscsi debian/open-iscsi.finalrd usr/share/finalrd/
	dh_install -p open-iscsi etc/systemd/iscsid.socket lib/systemd/system/
	mkdir -p debian/open-iscsi/usr/bin
	ln -s /sbin/iscsiadm debian/open-iscsi/usr/bin/iscsiadm
	mkdir -p debian/open-iscsi/usr/share/initramfs-tools/hooks
	mkdir -p debian/open-iscsi/usr/share/initramfs-tools/scripts/local-top/
	mkdir -p debian/open-iscsi/usr/share/initramfs-tools/scripts/local-bottom/
	cp -p debian/extra/initramfs.hook debian/open-iscsi/usr/share/initramfs-tools/hooks/iscsi
	cp -p debian/extra/initramfs.local-top debian/open-iscsi/usr/share/initramfs-tools/scripts/local-top/iscsi
	cp -p debian/extra/initramfs.local-bottom debian/open-iscsi/usr/share/initramfs-tools/scripts/local-bottom/iscsi
	mkdir -p debian/open-iscsi/lib/udev/rules.d/
	cp -p debian/open-iscsi.rules debian/open-iscsi/lib/udev/rules.d/70-open-iscsi.rules
	cp -p debian/iscsi-network-interface.rules debian/open-iscsi/lib/udev/rules.d/70-iscsi-network-interface.rules

	@# iscsiuio
	dh_install -p iscsiuio iscsiuio/src/unix/iscsiuio /sbin
	mkdir -p debian/iscsiuio/usr/share/initramfs-tools/hooks
	cp -p debian/extra/iscsiuio.initramfs.hook debian/iscsiuio/usr/share/initramfs-tools/hooks/iscsiuio

	@# open-iscsi-udeb
	dh_install -p open-iscsi-udeb usr/iscsid sbin/
	dh_install -p open-iscsi-udeb usr/iscsistart sbin/
	dh_install -p open-iscsi-udeb usr/iscsiadm sbin/
	dh_install -p open-iscsi-udeb utils/iscsi_discovery sbin/
	dh_install -p open-iscsi-udeb utils/iscsi-iname sbin/
	dh_install -p open-iscsi-udeb etc/iscsid.conf etc/iscsi/
	dh_install -p open-iscsi-udeb debian/open-iscsi-udeb.start sbin/iscsi-start
	dh_install -p open-iscsi-udeb debian/open-iscsi-udeb.finish-install usr/lib/finish-install.d/10open-iscsi

override_dh_installinit:
	dh_installinit -p open-iscsi --no-start --no-enable --no-stop-on-upgrade --name=iscsid
	dh_installinit -p open-iscsi --no-start --no-enable --no-stop-on-upgrade
	dh_installinit -p iscsiuio --no-start --no-enable --no-stop-on-upgrade

override_dh_systemd_enable:
	dh_systemd_enable -p open-iscsi --name=iscsid --no-enable iscsid.service
	dh_systemd_enable -p open-iscsi --name=iscsid iscsid.socket
	dh_systemd_enable -p open-iscsi open-iscsi.service
	dh_systemd_enable -p iscsiuio

override_dh_systemd_start:
	dh_systemd_start -p open-iscsi --no-restart-on-upgrade iscsid.socket
	dh_systemd_start -p open-iscsi --no-restart-on-upgrade open-iscsi.service
	dh_systemd_start -p iscsiuio --no-restart-on-upgrade iscsiuio.service

override_dh_installman:
	dh_installman -p open-iscsi ./doc/*
	dh_installman -p libopeniscsiusr-dev ./libopeniscsiusr/docs/man/*
	dh_installman -p iscsiuio iscsiuio/docs/*

override_dh_installdocs:
	dh_installdocs -p open-iscsi README sysfs-documentation THANKS
	dh_installdocs -p iscsiuio iscsiuio/RELEASE.TXT iscsiuio/README
	dh_installdocs -p libopeniscsiusr0.2.0 ./libopeniscsiusr/docs/doc-preclean.pl ./libopeniscsiusr/docs/kernel-doc ./libopeniscsiusr/docs/libopeniscsiusr.h.3 ./libopeniscsiusr/docs/split-man.pl
	dh_installdocs -p libopeniscsiusr-dev

override_dh_missing:
	dh_missing --fail-missing

# The following is taken from the initramfs-tools package. (We recommend
# busybox in the initramfs because otherwise we don't have access to the
# ip utility to set the default gateway after iscsistart -N is done.)
# On Debian we can use either busybox or busybox-static, but on Ubuntu
# and derivatives only busybox-initramfs will work.
BUSYBOX_PACKAGES := $(shell if dpkg-vendor --derives-from ubuntu; then echo busybox-initramfs; else echo busybox busybox-static; fi)

override_dh_gencontrol:
	echo >> debian/open-iscsi.substvars "busybox:Recommends=$(wordlist 2,100,$(BUSYBOX_PACKAGES:%=| %))"
	dh_gencontrol

=== debian/tests/control ===
Tests: install
Restrictions: needs-root, isolation-machine, breaks-testbed

Tests: testsuite
Restrictions: needs-root isolation-machine breaks-testbed
Depends: open-iscsi, python2, tgt, qemu-system, ubuntu-cloudimage-keyring, simplestreams, python-netifaces, distro-info, cloud-image-utils, dctrl-tools, rsync

Tests: nested
Restrictions: needs-root, isolation-machine, breaks-testbed, allow-stderr
Depends: targetcli-fb, qemu-system, qemu-utils, python3, python3-netifaces

## open-iscsi 2.1.3

=== usr/Makefile ===
# This Makefile will work only with GNU make.

ifeq ($(TOPDIR),)
	TOPDIR = ..
endif

OSNAME=$(shell uname -s)

# allow users to override these
# eg to compile for a kernel that you aren't currently running
KERNELRELEASE ?= $(shell uname -r)
KSRC ?= /lib/modules/$(KERNELRELEASE)/build

KSUBLEVEL=$(shell cat $(KSRC)/Makefile | awk -F= '/^SUBLEVEL =/ {print $$2}' | \
			sed 's/^[ \t]*//;s/[ \t]*$$//')

ifeq ($(OSNAME),Linux)
	ifeq ($(KSUBLEVEL),11)
		IPC_CFLAGS=-DNETLINK_ISCSI=12 -D_GNU_SOURCE
	else
	ifeq ($(KSUBLEVEL),12)
		IPC_CFLAGS=-DNETLINK_ISCSI=12 -D_GNU_SOURCE
	else
		IPC_CFLAGS=-DNETLINK_ISCSI=8 -D_GNU_SOURCE
	endif
	endif
IPC_OBJ=netlink.o
else
ifeq ($(OSNAME),FreeBSD)
IPC_CFLAGS=
IPC_OBJ=ioctl.o
endif
endif

PKG_CONFIG = /usr/bin/pkg-config

CFLAGS ?= -O2 -g
WARNFLAGS ?= -Wall -Wextra -Werror -Wstrict-prototypes -fno-common
CFLAGS += $(WARNFLAGS) -I../include -I. -D_GNU_SOURCE \
	  -I$(TOPDIR)/libopeniscsiusr
CFLAGS += $(shell $(PKG_CONFIG) --cflags libkmod)
ISCSI_LIB = -L$(TOPDIR)/libopeniscsiusr -lopeniscsiusr
LDFLAGS += $(shell $(PKG_CONFIG) --libs libkmod)
ifeq ($(NO_SYSTEMD),)
LDFLAGS += $(shell $(PKG_CONFIG) --libs libsystemd)
endif
PROGRAMS = iscsid iscsiadm iscsistart

# libc compat files
SYSDEPS_SRCS = $(sort $(wildcard ../utils/sysdeps/*.o))
# sources shared between iscsid, iscsiadm and iscsistart
ISCSI_LIB_SRCS = iscsi_util.o io.o auth.o iscsi_timer.o login.o log.o \
	iface.o idbm.o sysfs.o host.o session_info.o iscsi_sysfs.o \
	iscsi_net_util.o iscsid_req.o transport.o iser.o cxgbi.o be2iscsi.o \
	initiator_common.o iscsi_err.o flashnode.o uip_mgmt_ipc.o \
	netlink.o $(SYSDEPS_SRCS)
# core initiator files
INITIATOR_SRCS = initiator.o scsi.o actor.o event_poll.o mgmt_ipc.o kern_err_table.o

# fw boot files
FW_BOOT_SRCS = $(sort $(wildcard ../utils/fwparam_ibft/*.o))

# core discovery files
DISCOVERY_SRCS = $(FW_BOOT_SRCS) local_strings.o discovery.o

all: $(PROGRAMS)

iscsid: $(ISCSI_LIB_SRCS) $(INITIATOR_SRCS) $(DISCOVERY_SRCS) \
	iscsid.o session_mgmt.o discoveryd.o mntcheck.o
	$(CC) $(CFLAGS) $^ -o $@  -lisns -lcrypto -lrt -lmount $(LDFLAGS) $(ISCSI_LIB)

iscsiadm: $(ISCSI_LIB_SRCS) $(DISCOVERY_SRCS) iscsiadm.o session_mgmt.o mntcheck.o
	$(CC) $(CFLAGS) $^ -o $@ -lisns -lcrypto -lmount $(LDFLAGS) $(ISCSI_LIB)

iscsistart: $(ISCSI_LIB_SRCS) $(INITIATOR_SRCS) $(FW_BOOT_SRCS) \
		iscsistart.o statics.o
	$(CC) $(CFLAGS) $^ -o $@ -lcrypto -lrt $(LDFLAGS) $(ISCSI_LIB)
clean:
	rm -f *.o $(PROGRAMS) .depend $(LIBSYS)

depend:
	gcc $(CFLAGS) -M `ls *.c` > .depend

-include .depend

=== utils/Makefile ===
# This Makefile will work only with GNU make.

CFLAGS ?= -O2 -fno-inline -g
CFLAGS += -Wall -Wextra -Wstrict-prototypes
PROGRAMS = iscsi-iname

all: $(PROGRAMS)

iscsi-iname: md5.o iscsi-iname.o
	$(CC) $(CFLAGS) $(LDFLAGS) $^ $(DBM_LIB) -o $@

clean:
	rm -f *.o $(PROGRAMS) .depend

depend:
	gcc $(CFLAGS) -M `ls *.c` > .depend

-include .depend

=== debian/changelog ===
open-iscsi (2.1.3-5) unstable; urgency=medium

  [ Cyril Brulebois ]
  * [3b8b2d8] Revert "Set architecture for build to linux-any"
  * [1297e50] Adjust dh_auto_install and dh_makeshlibs overrides for the conditional udeb.

 -- Ritesh Raj Sarraf <rrs@debian.org>  Thu, 20 May 2021 19:52:30 +0530

open-iscsi (2.1.3-4) unstable; urgency=medium

  * [8142984] Set architecture for build to linux-any. This ensures that the
    library is built on the right set of architectures and dh_makeshlibs is
    invoked appropriately. (Closes: #987858)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Tue, 04 May 2021 21:45:56 +0530

open-iscsi (2.1.3-3) unstable; urgency=medium

  * [47645a5] Make open-iscsi-udeb compatible with d-i.
    Thanks to Cyril Brulebois (Closes: #987568)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Thu, 29 Apr 2021 13:43:35 +0530

open-iscsi (2.1.3-2) unstable; urgency=medium

  * [c3b7109] Fix FTCBFS:
    Let dh_auto_configure pass --host to iscsiuio/configure.
    Thanks to Helmut Grohne <helmut@subdivi.de> (Closes: #898758)
  * [efb5512] Add patches from upstream:
    Fix memory leak in iscsiadm, Fix iscsiadm segfault when exiting, and
    Fix iscsistart login issue when target is delayed. The last one should
    fix #980085. (Closes: #980085)

 -- Chris Hofstaedtler <zeha@debian.org>  Sun, 07 Feb 2021 19:23:13 +0000

open-iscsi (2.1.3-1) unstable; urgency=medium

  * [afee47d] New upstream version 2.1.3
    - Fixes CVE-2020-13987, CVE-2020-17437, CVE-2020-13988.
  * [236761e] Mark open-iscsi, iscsiuio M-A: foreign (Closes: #941099)
  * [3e25b6a] d/README.source: remove obsolete get-orig-source note
  * [296cd55] Explicitly set build date for docs.
    Thanks to Chris Lamb <lamby@debian.org> (Closes: #975046)

 -- Chris Hofstaedtler <zeha@debian.org>  Thu, 24 Dec 2020 00:09:46 +0000

open-iscsi (2.1.2-2) unstable; urgency=medium

  * Source-only upload to allow testing migration.
  * Add myself to Uploaders.

 -- Chris Hofstaedtler <zeha@debian.org>  Sun, 06 Dec 2020 23:25:11 +0000

open-iscsi (2.1.2-1) unstable; urgency=medium

  * [7f10701] New upstream version 2.1.2
  * [51e4a23] Drop all patches
  * [94b33e9] Fix Vcs-Browser link
  * [36f52c9] Add a news entry about linkage with OpenSSL
  * [8bee5c7] Update d/copyright with copyright and license information
  * [02bacbf] Remove unused code to parse changelog
  * [72bc9ac] Set libopensicsiusr-dev to arch:all as it has no
    architecture dependent files

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sun, 15 Nov 2020 17:09:06 +0530

open-iscsi (2.1.1-2) unstable; urgency=medium

  * Upload to Unstable
  * [71e9333] Set to master
  * [dd49a5a] Add patches to fix compiler warnings

 -- Ritesh Raj Sarraf <rrs@debian.org>  Fri, 14 Aug 2020 12:32:16 +0530

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: open-iscsi
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian iSCSI Maintainers <open-iscsi@packages.debian.org>
+Maintainer: Debian iSCSI Maintainers <open-iscsi@packages.debian.org>
 Uploaders: Ritesh Raj Sarraf <rrs@debian.org>,
-           Christian Seiler <christian@iwakd.de>
+           Christian Seiler <christian@iwakd.de>,
+           Chris Hofstaedtler <zeha@debian.org>
 Build-Depends: bison,
                bzip2,
                debhelper (>= 10),
@@ -19,18 +19,18 @@
                libssl-dev
 Standards-Version: 4.5.0
 Vcs-Git: https://salsa.debian.org/linux-blocks-team/open-iscsi.git
-Vcs-Browser: https://salsa.debian.org/linux-blocks-team/open-iscsi.git
+Vcs-Browser: https://salsa.debian.org/linux-blocks-team/open-iscsi
 Homepage: http://www.open-iscsi.com/
 Testsuite: autopkgtest
 Rules-Requires-Root: no
 
 Package: open-iscsi
 Architecture: linux-any
+Multi-Arch: foreign
 Depends: ${misc:Depends},
          ${shlibs:Depends},
-         libopeniscsiusr0.2.0,
+         libopeniscsiusr,
          udev
-Recommends: ${busybox:Recommends}, finalrd (>= 3)
 Pre-Depends: debconf | debconf-2.0
 Description: iSCSI initiator tools
  The Open-iSCSI project is a high-performance, transport independent,
@@ -54,7 +54,7 @@
  This package includes a daemon, iscsid, and a management utility,
  iscsiadm.
 
-Package: libopeniscsiusr0.2.0
+Package: libopeniscsiusr
 Architecture: linux-any
 Depends: ${misc:Depends},
          ${shlibs:Depends}
@@ -81,9 +81,9 @@
  This package contains the iSCSI userspace library.
 
 Package: libopeniscsiusr-dev
-Architecture: linux-any
+Architecture: all
 Depends: ${misc:Depends},
-         libopeniscsiusr0.2.0 (= ${binary:Version})
+         libopeniscsiusr
 Enhances: open-iscsi
 Description: iSCSI userspace library headers
  The Open-iSCSI project is a high-performance, transport independent,
@@ -108,9 +108,10 @@
 
 Package: iscsiuio
 Architecture: linux-any
+Multi-Arch: foreign
 Depends: ${misc:Depends},
          ${shlibs:Depends},
-         libopeniscsiusr0.2.0,
+         libopeniscsiusr,
          udev
 Enhances: open-iscsi
 Description: iSCSI offloading daemon for QLogic devices
@@ -138,13 +139,11 @@
 #       linux kernel udebs) must exist for these architectures - so
 #       check that before adding them to this list; the other
 #       scsi-(core|common|...)-modules are NOT sufficient!
-Architecture: amd64 arm64 armhf ia64 mips mipsel powerpc ppc64 ppc64el s390x
+Architecture: amd64 arm64 armhf i386 ia64 mips mipsel powerpc ppc64 ppc64el s390x
 Section: debian-installer
 Package-Type: udeb
 Depends: ${misc:Depends},
          ${shlibs:Depends},
-         libopeniscsiusr0.2.0,
-         udev,
          scsi-modules
 Description: Configure iSCSI
  The Open-iSCSI project is a high-performance, transport independent,

=== debian/rules ===
#!/usr/bin/make -f
# export DH_VERBOSE = 1

DEB_HOST_MULTIARCH  ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

include /usr/share/dpkg/pkg-info.mk
export KBUILD_BUILD_TIMESTAMP = @$(SOURCE_DATE_EPOCH)

UDEB := $(filter open-iscsi-udeb,$(shell dh_listpackages))

%:
	dh $@

override_dh_update_autotools_config:
override_autoreconf:
override_dh_auto_configure:

override_dh_auto_build:
	@# Let debhelper pass configure flags.
	dh_auto_configure --sourcedirectory=iscsiuio

	CFLAGS="$(CPPFLAGS) $(CFLAGS)" dh_auto_build

override_dh_auto_install:

	@# libopeniscsiusr
	dh_install -p libopeniscsiusr libopeniscsiusr/libopeniscsiusr*.so.* usr/lib/${DEB_HOST_MULTIARCH}

	@# libopeniscsi-dev
	dh_install -p libopeniscsiusr-dev libopeniscsiusr/libopeniscsiusr/ usr/include/

	@# open-iscsi
	dh_install -p open-iscsi usr/iscsid sbin/
	dh_install -p open-iscsi usr/iscsistart sbin/
	dh_install -p open-iscsi usr/iscsiadm sbin/
	dh_install -p open-iscsi utils/iscsi_discovery sbin/
	dh_install -p open-iscsi utils/iscsi-iname sbin/
	dh_install -p open-iscsi etc/iscsid.conf etc/iscsi/
	dh_install -p open-iscsi debian/extra/umountiscsi.sh lib/open-iscsi/
	dh_install -p open-iscsi debian/extra/logout-all.sh lib/open-iscsi/
	dh_install -p open-iscsi debian/extra/startup-checks.sh lib/open-iscsi/
	dh_install -p open-iscsi debian/extra/activate-storage.sh lib/open-iscsi/
	mkdir -p debian/open-iscsi/usr/bin
	ln -s /sbin/iscsiadm debian/open-iscsi/usr/bin/iscsiadm
	mkdir -p debian/open-iscsi/usr/share/initramfs-tools/hooks
	mkdir -p debian/open-iscsi/usr/share/initramfs-tools/scripts/local-top/
	mkdir -p debian/open-iscsi/usr/share/initramfs-tools/scripts/local-bottom/
	cp -p debian/extra/initramfs.hook debian/open-iscsi/usr/share/initramfs-tools/hooks/iscsi
	cp -p debian/extra/initramfs.local-top debian/open-iscsi/usr/share/initramfs-tools/scripts/local-top/iscsi
	cp -p debian/extra/initramfs.local-bottom debian/open-iscsi/usr/share/initramfs-tools/scripts/local-bottom/iscsi
	mkdir -p debian/open-iscsi/lib/modules-load.d/
	cp -p debian/open-iscsi.kmod debian/open-iscsi/lib/modules-load.d/open-iscsi.conf
	mkdir -p debian/open-iscsi/lib/udev/rules.d/
	cp -p debian/open-iscsi.rules debian/open-iscsi/lib/udev/rules.d/70-open-iscsi.rules

	@# iscsiuio
	dh_install -p iscsiuio iscsiuio/src/unix/iscsiuio /sbin
	mkdir -p debian/iscsiuio/usr/share/initramfs-tools/hooks
	cp -p debian/extra/iscsiuio.initramfs.hook debian/iscsiuio/usr/share/initramfs-tools/hooks/iscsiuio

ifneq ($(UDEB),)
	@# open-iscsi-udeb
	dh_install -p open-iscsi-udeb usr/iscsid sbin/
	dh_install -p open-iscsi-udeb usr/iscsistart sbin/
	dh_install -p open-iscsi-udeb usr/iscsiadm sbin/
	dh_install -p open-iscsi-udeb utils/iscsi_discovery sbin/
	dh_install -p open-iscsi-udeb utils/iscsi-iname sbin/
	dh_install -p open-iscsi-udeb etc/iscsid.conf etc/iscsi/
	dh_install -p open-iscsi-udeb debian/open-iscsi-udeb.start sbin/iscsi-start
	dh_install -p open-iscsi-udeb debian/open-iscsi-udeb.finish-install usr/lib/finish-install.d/10open-iscsi

	# Ship shared libraries along with the executable in a single udeb
	dh_install -p open-iscsi-udeb libopeniscsiusr/libopeniscsiusr*.so.* usr/lib/${DEB_HOST_MULTIARCH}
endif

override_dh_installinit:
	dh_installinit -p open-iscsi --name=iscsid
	dh_installinit -p open-iscsi
	dh_installinit -p iscsiuio

override_dh_systemd_enable:
	dh_systemd_enable -p open-iscsi --name=iscsid
	dh_systemd_enable -p open-iscsi
	dh_systemd_enable -p iscsiuio

override_dh_systemd_start:
	dh_systemd_start -p open-iscsi --no-restart-on-upgrade iscsid.service open-iscsi.service
	dh_systemd_start -p iscsiuio --no-restart-on-upgrade iscsiuio.service

override_dh_installman:
	dh_installman -p open-iscsi ./doc/*
	dh_installman -p libopeniscsiusr-dev ./libopeniscsiusr/docs/man/*
	dh_installman -p iscsiuio iscsiuio/docs/*

override_dh_installdocs:
	dh_installdocs -p open-iscsi README sysfs-documentation THANKS
	dh_installdocs -p iscsiuio iscsiuio/RELEASE.TXT iscsiuio/README
	dh_installdocs -p libopeniscsiusr ./libopeniscsiusr/docs/doc-preclean.pl ./libopeniscsiusr/docs/kernel-doc ./libopeniscsiusr/docs/libopeniscsiusr.h.3 ./libopeniscsiusr/docs/split-man.pl
	dh_installdocs -p libopeniscsiusr-dev

override_dh_missing:
	dh_missing --fail-missing

override_dh_makeshlibs:
ifneq ($(UDEB),)
	dh_makeshlibs --add-udeb=open-iscsi-udeb
else
	dh_makeshlibs
endif

=== debian/tests/control ===
Tests: install
Restrictions: needs-root, isolation-machine, breaks-testbed

Tests: nested
Restrictions: needs-root, isolation-machine, breaks-testbed, allow-stderr
Depends: targetcli-fb, qemu-system, qemu-utils, python3, python3-netifaces

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/open-iscsi-$1\.tar\.gz/ \
  https://github.com/open-iscsi/open-iscsi/releases .*/v?(\d\S*)\.tar\.gz

## open-iscsi 2.1.4

=== debian/changelog ===
open-iscsi (2.1.4-0ubuntu1) impish; urgency=medium

  * Merge with Debian unstable (LP: #1934290). Remaining changes:
    - debian/tests: Add Ubuntu autopkgtest suite:
      + d/t/README-boot-test.md: document test design
      + d/t/control: register testsuite
      + d/t/get-image: helper to fetch an ubuntu cloud image
      + d/t/patch-image: helper to modify an ubuntu cloud image
      + d/test-open-iscsi.py, d/t/testlib.py: various qa regression tests
      + d/t/testsuite: helper to invoke qa regression tests
      + d/t/tgt-boot-test: test using tgt to boot from iscsi
      + d/t/xkvm: helper to spawn a VM
      Note: this suite should be replaced by LIO that replaced TGT in main.
    - d/iscsid.service: Let iscsid systemd job run in privileged containers
      but not in unprivileged ones
    - debian/extra/initramfs.local-top: handle iSCSI iBFT DHCP to correctly
      run ipconfig to gather all DHCP config info, including DNS search
      domain, which iBFT can't provide.
    - Remove initramfs interfaces stamp in case no iscsi devs mounted
      If iscsi root was requested, but no iscsi devices were mounted, remove
      the initramfs interfaces stamp file. Meaning, that on shutdown there is
      no 30s delay, whilst trying to re-establish iscsi login to perform a
      logout.
    - add IPv6 support
      + Source /run/net6-*.conf when needed.
      + debian/extra/initramfs.local-top: handle IPv6 configs being shipped
        in DEVICE6 or /run/net6-*.conf in the initramfs, so we can fill in
        /run/initramfs/open-iscsi.interface
    - d/rules, d/open-iscsi.finalrd, d/control: ship the finalrd iscsi
      logout hook and recommend finalrd and busybox for the logout hook
      to work.
    - Make iscsid socket-activated to only activate it as needed:
      + debian/open-iscsi.service: do not start or check iscsid.service
      + debian/rules: install and enable iscsid.socket
      + debian/open-iscsi.postinst:
        + run restart logic only if service is running on upgrade
        + drop no longer reachable upgrade path that affects iscsid
        + disable iscsid.service on upgrade
        + handle iscsid.socket to be started if the service is not running yet
      + d/iscsi-disk.rules: Add a udev rule so that iscsid.service will be
        run when udev disks are attached.
      + d/iscsid.service: Remove ExecStop= directive.
      + debian/tests/install: fix tests to work with socket activation
      + debian/patches/lp1755858-default-iscsid_conf-to-iscsid_socket.patch
    - debian/open-iscsi.service: Start open-iscsi systemd job when either
      /etc/iscsi/nodes or /sys/class/iscsi_session have content.
    - Prevent network interface that contains iscsi root from bouncing
      during boot or going down during shutdown if the system is using
      resolvconf or ifupdown:
      + d/iscsi-network-interface.rules
      + d/extra/net-interface-handler
    - debian/extra/initramfs.hook: add ib_iser to the list of modules
      included in the initramfs, so that we can in principle support
      iscsi root on infiniband.
    - debian/open-iscsi.kmod drop: (LP 1833586)
      no static module list is needed if we let iscsid load modules itself.
    - Stop producing udebs on i386 where we no longer have d-i or a kernel.
    - d/extra/initramfs.local-{top,bottom}: move removal of
      open-iscsi.interface file from local-top to local-bottom,
      and fix shell quoting issue that would result in /run/initramfs/
      open-iscsi.interface always being removed (LP 1872813)
    - d/rules: Don't FTBFS due to warnings new in gcc10 regarding bounds and
      initialization, because upstream's gcc10 support is incomplete. This
      change can be dropped when upstream has completed their gcc support.
    - d/README.Debian, d/extra/startup-checks.sh, d/open-iscsi-udeb.start,
      d/open-iscsi.postinst: Apply Ubuntu branding to iqn initiator name
  * Added changes
    - merge bug fix release 2.1.4 from upstream
    - Revert "Add patches from upstream" [upstream in 2.1.4]
    - d/control: Transition from libopeniscsiusr0.2.0 to libopeniscsiusr

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Thu, 01 Jul 2021 14:13:08 +0200

open-iscsi (2.1.3-1ubuntu6) hirsute; urgency=medium

  * d/open-iscsi.finalrd: fix UID resolution issues in logout (LP: #1922976)
    Thanks to Michael Brown

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Thu, 18 Mar 2021 09:44:07 +0100

open-iscsi (2.1.3-1ubuntu5) hirsute; urgency=medium

  * make d/t/testuite python3 compatible (LP: #1919461)
    - backport changes from qa-regression-testing since we diverged
      - various tests: make py3 compliant, fix formatting a bit
      - tests: convert deprecated assertEquals() to assertEqual()
      - Remove all references to python-utils
    - d/t/testlib.py: update to last state from
      git+ssh://git.launchpad.net/qa-regression-testing
    - d/t/{control,testsuite}: bump to use python3
    - d/t/test-open-iscsi.py: switch shebang to python3
    - d/t/test-open-iscsi.py: adapt to updated testlib
  * Add patches from upstream [this is from Debian upload 2.1.3-2]:
    - Fix memory leak in iscsiadm, Fix iscsiadm segfault when exiting, and
    - Fix iscsistart login issue when target is delayed. The last one should
    - fix iscsi-root with delayed network (Closes: #980085)

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Thu, 18 Mar 2021 09:44:07 +0100

open-iscsi (2.1.3-1ubuntu4) hirsute; urgency=medium

  * Rebuild again so s390x pick up the right debhelper

 -- Sebastien Bacher <seb128@ubuntu.com>  Wed, 24 Feb 2021 16:29:41 +0100

open-iscsi (2.1.3-1ubuntu3) hirsute; urgency=medium

  * No-change rebuild to drop the udeb package.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 22 Feb 2021 10:35:42 +0100

open-iscsi (2.1.3-1ubuntu2) hirsute; urgency=medium

  * Apply Ubuntu branding to iqn initiator name.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 17 Feb 2021 00:05:22 +0000



=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: open-iscsi
 Section: net
 Priority: optional
-Maintainer: Debian iSCSI Maintainers <open-iscsi@packages.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian iSCSI Maintainers <open-iscsi@packages.debian.org>
 Uploaders: Ritesh Raj Sarraf <rrs@debian.org>,
            Christian Seiler <christian@iwakd.de>,
            Chris Hofstaedtler <zeha@debian.org>
@@ -31,6 +32,7 @@
          ${shlibs:Depends},
          libopeniscsiusr,
          udev
+Recommends: ${busybox:Recommends}, finalrd (>= 3)
 Pre-Depends: debconf | debconf-2.0
 Description: iSCSI initiator tools
  The Open-iSCSI project is a high-performance, transport independent,
@@ -58,6 +60,8 @@
 Architecture: linux-any
 Depends: ${misc:Depends},
          ${shlibs:Depends}
+Replaces: libopeniscsiusr0.2.0 (<< 2.1.4-0ubuntu1~)
+Breaks: libopeniscsiusr0.2.0 (<< 2.1.4-0ubuntu1~)
 Enhances: open-iscsi
 Description: iSCSI userspace library
  The Open-iSCSI project is a high-performance, transport independent,
@@ -139,7 +143,7 @@
 #       linux kernel udebs) must exist for these architectures - so
 #       check that before adding them to this list; the other
 #       scsi-(core|common|...)-modules are NOT sufficient!
-Architecture: amd64 arm64 armhf i386 ia64 mips mipsel powerpc ppc64 ppc64el s390x
+Architecture: amd64 arm64 armhf ia64 mips mipsel powerpc ppc64 ppc64el s390x
 Section: debian-installer
 Package-Type: udeb
 Depends: ${misc:Depends},
@@ -150,3 +154,11 @@
  multi-platform implementation of RFC3720 iSCSI.
  .
  This is the minimal package (udeb) used by debian-installer.
+
+Package: libopeniscsiusr0.2.0
+Depends: libopeniscsiusr, ${misc:Depends}
+Architecture: all
+Priority: optional
+Section: oldlibs
+Description: transitional package
+ This is a transitional package. It can safely be removed.

=== debian/rules ===
--- 
+++ 
@@ -10,6 +10,10 @@
 export KBUILD_BUILD_TIMESTAMP = @$(SOURCE_DATE_EPOCH)
 
 UDEB := $(filter open-iscsi-udeb,$(shell dh_listpackages))
+
+# Fix gcc10 warnings as errors while upstream doesn't catch up
+export DEB_CFLAGS_PREPEND=-Wno-error=zero-length-bounds -Wno-error=format-overflow= -Wno-error=format-truncation= -Wno-error=maybe-uninitialized
+export DEB_CXXFLAGS_PREPEND=${DEB_CFLAGS_PREPEND}
 
 %:
 	dh $@
@@ -43,6 +47,9 @@
 	dh_install -p open-iscsi debian/extra/logout-all.sh lib/open-iscsi/
 	dh_install -p open-iscsi debian/extra/startup-checks.sh lib/open-iscsi/
 	dh_install -p open-iscsi debian/extra/activate-storage.sh lib/open-iscsi/
+	dh_install -p open-iscsi debian/extra/net-interface-handler lib/open-iscsi/
+	dh_install -p open-iscsi debian/open-iscsi.finalrd usr/share/finalrd/
+	dh_install -p open-iscsi etc/systemd/iscsid.socket lib/systemd/system/
 	mkdir -p debian/open-iscsi/usr/bin
 	ln -s /sbin/iscsiadm debian/open-iscsi/usr/bin/iscsiadm
 	mkdir -p debian/open-iscsi/usr/share/initramfs-tools/hooks
@@ -51,10 +58,9 @@
 	cp -p debian/extra/initramfs.hook debian/open-iscsi/usr/share/initramfs-tools/hooks/iscsi
 	cp -p debian/extra/initramfs.local-top debian/open-iscsi/usr/share/initramfs-tools/scripts/local-top/iscsi
 	cp -p debian/extra/initramfs.local-bottom debian/open-iscsi/usr/share/initramfs-tools/scripts/local-bottom/iscsi
-	mkdir -p debian/open-iscsi/lib/modules-load.d/
-	cp -p debian/open-iscsi.kmod debian/open-iscsi/lib/modules-load.d/open-iscsi.conf
 	mkdir -p debian/open-iscsi/lib/udev/rules.d/
 	cp -p debian/open-iscsi.rules debian/open-iscsi/lib/udev/rules.d/70-open-iscsi.rules
+	cp -p debian/iscsi-network-interface.rules debian/open-iscsi/lib/udev/rules.d/70-iscsi-network-interface.rules
 
 	@# iscsiuio
 	dh_install -p iscsiuio iscsiuio/src/unix/iscsiuio /sbin
@@ -77,17 +83,19 @@
 endif
 
 override_dh_installinit:
-	dh_installinit -p open-iscsi --name=iscsid
-	dh_installinit -p open-iscsi
-	dh_installinit -p iscsiuio
+	dh_installinit -p open-iscsi --no-start --no-enable --no-stop-on-upgrade --name=iscsid
+	dh_installinit -p open-iscsi --no-start --no-enable --no-stop-on-upgrade
+	dh_installinit -p iscsiuio --no-start --no-enable --no-stop-on-upgrade
 
 override_dh_systemd_enable:
-	dh_systemd_enable -p open-iscsi --name=iscsid
-	dh_systemd_enable -p open-iscsi
+	dh_systemd_enable -p open-iscsi --name=iscsid --no-enable iscsid.service
+	dh_systemd_enable -p open-iscsi --name=iscsid iscsid.socket
+	dh_systemd_enable -p open-iscsi open-iscsi.service
 	dh_systemd_enable -p iscsiuio
 
 override_dh_systemd_start:
-	dh_systemd_start -p open-iscsi --no-restart-on-upgrade iscsid.service open-iscsi.service
+	dh_systemd_start -p open-iscsi --no-restart-on-upgrade iscsid.socket
+	dh_systemd_start -p open-iscsi --no-restart-on-upgrade open-iscsi.service
 	dh_systemd_start -p iscsiuio --no-restart-on-upgrade iscsiuio.service
 
 override_dh_installman:
@@ -110,3 +118,14 @@
 else
 	dh_makeshlibs
 endif
+
+# The following is taken from the initramfs-tools package. (We recommend
+# busybox in the initramfs because otherwise we don't have access to the
+# ip utility to set the default gateway after iscsistart -N is done.)
+# On Debian we can use either busybox or busybox-static, but on Ubuntu
+# and derivatives only busybox-initramfs will work.
+BUSYBOX_PACKAGES := $(shell if dpkg-vendor --derives-from ubuntu; then echo busybox-initramfs; else echo busybox busybox-static; fi)
+
+override_dh_gencontrol:
+	echo >> debian/open-iscsi.substvars "busybox:Recommends=$(wordlist 2,100,$(BUSYBOX_PACKAGES:%=| %))"
+	dh_gencontrol
